unit propexp_2;

{
  Copyright  1998 CYborg Software, Inc.

  Property Expert
}
{checked 24/05/2000 BI}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  editintf, CybExprtBase,
  ExptIntf, ToolIntf;

type
  TPropWizard = class(TCybExpertBaseClass)
  private
    fMenuItem : TIMenuItemIntF;
    fMenuList : Tlist;

  public
    constructor Create;
    destructor Destroy; override;
    procedure Execute; override;
    function GetAuthor: string; override;
    function GetComment: string; override;
    function GetGlyph: HICON; override;
    function GetIDString: string; override;
    function GetMenuText: string; override;
    function GetName: string; override;
    function GetPage: string; override;
    function GetState: TExpertState; override;
    function GetStyle: TExpertStyle; override;
    procedure MenuItemClick(Sender: TIMenuItemIntF);
    function InsertMenuItem(  TargetName, Caption, Name, Hint: string;
                                      ShortCut, Context, GroupIndex: Integer;
                                      Flags: TIMenuFlags;
                                      EventHandler: TIMenuClickEvent): TIMenuItemIntf;

  end;

procedure Register;

implementation

uses   cybmanip, Propform ;


procedure Register;
begin
  RegisterLibraryExpert(TPropWizard.Create);
end;

resourcestring
  sAuthor = 'Boris Ingram';
  sCo ='Cyborg Software';
  sComment = 'For Delphi 4';
  sName = 'Property Expert 4';
  sMenuText = 'Prop E&xpert';
  sMenuName = 'PropertyExpertItem';
  sDelphiItem = 'ToolsMenu';

{ Create the expert and its menu. }
constructor TPropWizard.Create;
var
  lc : integer;
  bstr,astr : string;
  tempMenuItem: TIMenuItemIntf;

begin
  inherited Create;
  PropExpert := TPropExpert.Create(Application);
  fMenuItem := InsertMenuItem( sDelphiItem, sMenuText, sMenuName, '',
                              0, 0, 0, [mfVisible,mfenabled], nil);
  fMenuList := Tlist.create;
      for lc := SetProperties to lastverb do begin
        astr := PropExpert.MyGetVerb(lc);
        bstr := 'ExptItem'+inttostr(lc);
        tempMenuItem:= fMenuItem.InsertItem(lc, astr, bstr, '', 0, 0, 0, [mfVisible,mfenabled], MenuItemClick);
        fMenuList.add(tempMenuItem);
      end;
end;

{ Free the expert when freeing the data module. }
destructor TPropWizard.Destroy;
var
  lc : integer;
  tempMenuItem: TIMenuItemIntf;

begin
  PropExpert.free;
  for lc := SetProperties to lastverb do begin
        tempMenuItem:= TIMenuItemIntf(fMenuList[lc]);
        tempMenuItem.free;
  end;
  fMenuList.free;
  fMenuItem.Free;
  inherited Destroy;
end;

function TPropWizard.InsertMenuItem(  TargetName, Caption, Name, Hint: string;
                                      ShortCut, Context, GroupIndex: Integer;
                                      Flags: TIMenuFlags;
                                      EventHandler: TIMenuClickEvent): TIMenuItemIntf;
var
  TargetItem: TIMenuItemIntf;
  ParentItem: TIMenuItemIntf;
  Index: Integer;
begin
  Result := nil;
  { Get the menu bar interface. }
  with ToolServices.GetMainMenu do
    try
      { Look up the target menu item. }
      TargetItem := FindMenuItem(TargetName);
      if TargetItem = nil then
        raise Exception.CreateFmt('Cannot Find Menu Item %S', [TargetName]);
      try
          { To create a sibling of the target, get the
            targets parent. }
          ParentItem := TargetItem.GetParent;
          Index := TargetItem.GetIndex+1;
        if ParentItem = nil then
          raise Exception.CreateFmt('%s- No Menu Parent', [TargetName]);
        try
          Result := ParentItem.InsertItem(Index,
                        Caption, Name, Hint, ShortCut, Context,
                        GroupIndex, Flags, EventHandler);
        finally
          ParentItem.Free;
        end;
      finally
        TargetItem.Free;
      end;
    finally
      Free;
    end;
end;


function TPropWizard.GetStyle: TExpertStyle;
begin
  Result := esAddIn;
end;

function TPropWizard.GetIDString: string;
begin
  Result := sCo+'.'+sname;
end;

function TPropWizard.GetName: string;
begin
  Result := sName;
end;

function TPropWizard.GetMenuText: string;
begin
  Result := '';
end;

procedure TPropWizard.Execute;
begin
end;

function TPropWizard.GetAuthor: string;
begin
  Result := sAuthor;
end;

function TPropWizard.GetComment: string;
begin
  Result := sComment;
end;

function TPropWizard.GetGlyph: HICON;
begin
  Result := 0;
end;

function TPropWizard.GetPage: string;
begin
  Result := '';
end;

function TPropWizard.GetState: TExpertState;
begin
  Result := [];
end;

procedure TPropWizard.MenuItemClick(Sender: TIMenuItemIntF);
var
  lc : integer;
  bstr,astr : string;

begin
     astr := sender.getname;
     if Stringin( 'ExptItem', astr) then begin
       lc := strtoint(astr);
       Insertext( PropExpert.MyExecuteVerb(lc));
     end;
end;




end.


